﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
'Author: Alexander Stolte - Fixed by Nicolás Cieri 14/09/24
'Version: 1.04

#DesignerProperty: Key: MaxRating, DisplayName: MaxRating, FieldType: Int, DefaultValue: 10, MinRange: 1
#DesignerProperty: Key: CurrentRating, DisplayName: CurrentRating, FieldType: Int, DefaultValue: 0, MinRange: 0

#Event: RatingChange(rating as int)

Sub Class_Globals
	Private mEventName As String
	Private mCallBack As Object
	Private mBase As B4XView
	Private xui As XUI
	Private xBackgroundView As B4XView
	Private xbmp_image, xbmp_grey_image As B4XBitmap
	Private current_ranking As Int
	Private g_MaxRating As Int
	Public Tag As Object
End Sub

Public Sub Initialize(Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	SetImages(FontToBitmap(Chr(0xF005), False, 30, xui.Color_ARGB(255, 255, 215, 0)), FontToBitmap(Chr(0xF005), False, 30, xui.Color_ARGB(255, 211, 211, 211)))
End Sub

Public Sub DesignerCreateView(Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.Tag = Me
	g_MaxRating = Props.Get("MaxRating")
	current_ranking = Props.Get("CurrentRating")
	xBackgroundView = xui.CreatePanel("xBackgroundView")
	mBase.AddView(xBackgroundView, 0, 0, mBase.Width, mBase.Height)
	AddRanking
End Sub

Public Sub setCurrentRating(Rating As Int)
	current_ranking = Rating
	BuildRanking
End Sub

Public Sub getCurrentRating As Int
	Return current_ranking
End Sub

Public Sub SetImages(active_image As B4XBitmap, inactive_image As B4XBitmap)
	xbmp_image = active_image
	xbmp_grey_image = inactive_image
	BuildRanking
End Sub

' Convertir texto a bitmap usando FontAwesome o Material Icons
Public Sub FontToBitmap(text As String, IsMaterialIcons As Boolean, FontSize As Float, color As Int) As B4XBitmap
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 32dip, 32dip)
	Dim cvs1 As B4XCanvas
	cvs1.Initialize(p)
	Dim fnt As B4XFont
	If IsMaterialIcons Then
		fnt = xui.CreateMaterialIcons(FontSize)
	Else
		fnt = xui.CreateFontAwesome(FontSize)
	End If
	Dim r As B4XRect = cvs1.MeasureText(text, fnt)
	Dim BaseLine As Int = cvs1.TargetRect.CenterY - r.Height / 2 - r.Top
	cvs1.DrawText(text, cvs1.TargetRect.CenterX, BaseLine, fnt, color, "CENTER")
	Dim b As B4XBitmap = cvs1.CreateBitmap
	cvs1.Release
	Return b
End Sub

Private Sub AddRanking
	xBackgroundView.RemoveAllViews
	For i = 0 To g_MaxRating - 1
		Dim ximg_image As B4XView = CreateImageView("img")
		ximg_image.Tag = i
		xBackgroundView.AddView(ximg_image, (mBase.Width / g_MaxRating) * i, 0, mBase.Width / g_MaxRating, mBase.Height)
		If i < current_ranking Then
			ximg_image.SetBitmap(xbmp_image)
		Else
			ximg_image.SetBitmap(xbmp_grey_image)
		End If
	Next
End Sub

Private Sub img_Click
	Dim clickedImage As B4XView = Sender
	Dim newRating As Int = clickedImage.Tag + 1
	If current_ranking <> newRating Then
		current_ranking = newRating
		'CallSub2(mCallBack, mEventName & "_RatingChange", current_ranking)
		BuildRanking
		RatingChanged
	End If
End Sub

Private Sub RatingChanged
	If xui.SubExists(mCallBack, mEventName & "_RatingChanged", 1) Then
		CallSub2(mCallBack, mEventName & "_RatingChanged",current_ranking)
	End If
End Sub

Private Sub BuildRanking
	For i = 0 To g_MaxRating - 1
		Dim ximg_image As B4XView = xBackgroundView.GetView(i)
		If i < current_ranking Then
			ximg_image.SetBitmap(xbmp_image)
		Else
			ximg_image.SetBitmap(xbmp_grey_image)
		End If
	Next
End Sub

Private Sub CreateImageView(EventName As String) As B4XView
	Dim tmp_iv As ImageView
	tmp_iv.Initialize(EventName)
	Return tmp_iv
End Sub
